<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: TFTP::TFTP_Transaction Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="classTFTP.html">TFTP</a></li><li class="navelem"><a class="el" href="classTFTP_1_1TFTP__Transaction.html">TFTP_Transaction</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classTFTP_1_1TFTP__Transaction-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">TFTP::TFTP_Transaction Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Internal class for TFTP processing.  
 <a href="classTFTP_1_1TFTP__Transaction.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="TFTP_8h_source.html">TFTP.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ab952bccc72460fbb123c8bfbd30b4a56"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTFTP_1_1TFTP__Transaction.html#ab952bccc72460fbb123c8bfbd30b4a56">TFTP_Transaction</a> ()</td></tr>
<tr class="memdesc:ab952bccc72460fbb123c8bfbd30b4a56"><td class="mdescLeft">&#160;</td><td class="mdescRight">Start a <a class="el" href="classTFTP.html" title="A TFTP server.">TFTP</a> transaction.  <a href="#ab952bccc72460fbb123c8bfbd30b4a56">More...</a><br /></td></tr>
<tr class="separator:ab952bccc72460fbb123c8bfbd30b4a56"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a98ea42d7912e6ccc33948e7adadf7259"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTFTP_1_1TFTP__Transaction.html#a98ea42d7912e6ccc33948e7adadf7259">processWRQ</a> ()</td></tr>
<tr class="memdesc:a98ea42d7912e6ccc33948e7adadf7259"><td class="mdescLeft">&#160;</td><td class="mdescRight">Process a client write request.  <a href="#a98ea42d7912e6ccc33948e7adadf7259">More...</a><br /></td></tr>
<tr class="separator:a98ea42d7912e6ccc33948e7adadf7259"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0b8e83b447d6c8321354a040f4f6a7c6"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTFTP_1_1TFTP__Transaction.html#a0b8e83b447d6c8321354a040f4f6a7c6">processRRQ</a> ()</td></tr>
<tr class="memdesc:a0b8e83b447d6c8321354a040f4f6a7c6"><td class="mdescLeft">&#160;</td><td class="mdescRight">Process a client read request.  <a href="#a0b8e83b447d6c8321354a040f4f6a7c6">More...</a><br /></td></tr>
<tr class="separator:a0b8e83b447d6c8321354a040f4f6a7c6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a46521d26eb68aac975fbb58e706804e8"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTFTP_1_1TFTP__Transaction.html#a46521d26eb68aac975fbb58e706804e8">sendAck</a> (uint16_t blockNumber)</td></tr>
<tr class="memdesc:a46521d26eb68aac975fbb58e706804e8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Send an acknowledgment back to the partner. A <a class="el" href="classTFTP.html" title="A TFTP server.">TFTP</a> acknowledgment packet contains an opcode (4) and a block number.  <a href="#a46521d26eb68aac975fbb58e706804e8">More...</a><br /></td></tr>
<tr class="separator:a46521d26eb68aac975fbb58e706804e8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a503c474a79b6b88c36b108bba9236e01"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTFTP_1_1TFTP__Transaction.html#a503c474a79b6b88c36b108bba9236e01">sendError</a> (uint16_t code, std::string message)</td></tr>
<tr class="memdesc:a503c474a79b6b88c36b108bba9236e01"><td class="mdescLeft">&#160;</td><td class="mdescRight">Send an error indication to the client.  <a href="#a503c474a79b6b88c36b108bba9236e01">More...</a><br /></td></tr>
<tr class="separator:a503c474a79b6b88c36b108bba9236e01"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab1dc0909b4d9416f2148a0ba68453a76"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTFTP_1_1TFTP__Transaction.html#ab1dc0909b4d9416f2148a0ba68453a76">setBaseDir</a> (std::string baseDir)</td></tr>
<tr class="memdesc:ab1dc0909b4d9416f2148a0ba68453a76"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the base dir for file access. If we are asked to put a file to the file system, this is the base relative directory.  <a href="#ab1dc0909b4d9416f2148a0ba68453a76">More...</a><br /></td></tr>
<tr class="separator:ab1dc0909b4d9416f2148a0ba68453a76"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4aa35c73d2f586e07e63ee7746e75e9e"><td class="memItemLeft" align="right" valign="top"><a id="a4aa35c73d2f586e07e63ee7746e75e9e"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTFTP_1_1TFTP__Transaction.html#a4aa35c73d2f586e07e63ee7746e75e9e">waitForAck</a> (uint16_t blockNumber)</td></tr>
<tr class="memdesc:a4aa35c73d2f586e07e63ee7746e75e9e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Wait for an acknowledgment from the client. After having sent data to the client, we expect an acknowledment back from the client. This function causes us to wait for an incoming acknowledgment. <br /></td></tr>
<tr class="separator:a4aa35c73d2f586e07e63ee7746e75e9e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a107d19467cce9f8437e8af166737070a"><td class="memItemLeft" align="right" valign="top">uint16_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTFTP_1_1TFTP__Transaction.html#a107d19467cce9f8437e8af166737070a">waitForRequest</a> (<a class="el" href="classSocket.html">Socket</a> *pServerSocket)</td></tr>
<tr class="memdesc:a107d19467cce9f8437e8af166737070a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Wait for a client request. A TFTP server waits for requests to send or receive files. A request can be either WRQ (write request) which is a request from the client to write a new local file or it can be a RRQ (read request) which is a request from the client to read a local file.  <a href="#a107d19467cce9f8437e8af166737070a">More...</a><br /></td></tr>
<tr class="separator:a107d19467cce9f8437e8af166737070a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Internal class for TFTP processing. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="ab952bccc72460fbb123c8bfbd30b4a56"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab952bccc72460fbb123c8bfbd30b4a56">&#9670;&nbsp;</a></span>TFTP_Transaction()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">TFTP::TFTP_Transaction::TFTP_Transaction </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Start a <a class="el" href="classTFTP.html" title="A TFTP server.">TFTP</a> transaction. </p>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a0b8e83b447d6c8321354a040f4f6a7c6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0b8e83b447d6c8321354a040f4f6a7c6">&#9670;&nbsp;</a></span>processRRQ()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void TFTP::TFTP_Transaction::processRRQ </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Process a client read request. </p>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="a98ea42d7912e6ccc33948e7adadf7259"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a98ea42d7912e6ccc33948e7adadf7259">&#9670;&nbsp;</a></span>processWRQ()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void TFTP::TFTP_Transaction::processWRQ </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Process a client write request. </p>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="a46521d26eb68aac975fbb58e706804e8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a46521d26eb68aac975fbb58e706804e8">&#9670;&nbsp;</a></span>sendAck()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void TFTP::TFTP_Transaction::sendAck </td>
          <td>(</td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>blockNumber</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Send an acknowledgment back to the partner. A <a class="el" href="classTFTP.html" title="A TFTP server.">TFTP</a> acknowledgment packet contains an opcode (4) and a block number. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">blockNumber</td><td>The block number to send. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="a503c474a79b6b88c36b108bba9236e01"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a503c474a79b6b88c36b108bba9236e01">&#9670;&nbsp;</a></span>sendError()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void TFTP::TFTP_Transaction::sendError </td>
          <td>(</td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>code</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>message</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Send an error indication to the client. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">code</td><td>Error code to send to the client. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">message</td><td>Explanation message. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="ab1dc0909b4d9416f2148a0ba68453a76"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab1dc0909b4d9416f2148a0ba68453a76">&#9670;&nbsp;</a></span>setBaseDir()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void TFTP::TFTP_Transaction::setBaseDir </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>baseDir</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Set the base dir for file access. If we are asked to put a file to the file system, this is the base relative directory. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">baseDir</td><td>Base directory for file access. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>N/A. </dd></dl>

</div>
</div>
<a id="a107d19467cce9f8437e8af166737070a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a107d19467cce9f8437e8af166737070a">&#9670;&nbsp;</a></span>waitForRequest()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint16_t TFTP::TFTP_Transaction::waitForRequest </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classSocket.html">Socket</a> *&#160;</td>
          <td class="paramname"><em>pServerSocket</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Wait for a client request. A TFTP server waits for requests to send or receive files. A request can be either WRQ (write request) which is a request from the client to write a new local file or it can be a RRQ (read request) which is a request from the client to read a local file. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">pServerSocket</td><td>The server socket on which to listen for client requests. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The op code received. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="TFTP_8h_source.html">TFTP.h</a></li>
<li>TFTP.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
